#!/bin/bash
#trap 'echo; echo dnl_live_monitor session finished at `date` | tee --append dnl_live_monitor.log; read -n 1 -s -r -p "Press any key to restart session"; exit' EXIT HUP TERM
set -euo pipefail

echo dnl_live_monitor session started at `date`  | tee --append dnl_live_monitor.log
echo dnl_live_monitor session received arguments $*  | tee --append dnl_live_monitor.log

if [ $# -ne 4 ]
then
    echo dnl_live_monitor session error: Wrong number of arguments, $# , expected 4 'or token length is too big, please check token then' | tee --append dnl_live_monitor.log
    exit 1
fi

echo dnl_live_monitor session received token: $3  | tee --append dnl_live_monitor.log

source settings.cfg

filter_host=$1
filter_port=$2
token=$3
gather_rtp=$4


auth_response=`curl -X POST $TOKEN_VALIDATION_URL --write-out '%{http_code}\n' -H  "accept: application/json" -H "X-Auth-Token: ${token}" -d "" --output /dev/null --silent --show-error`
if [ "$auth_response" -ne 200 ]
then
    echo "dnl_live_monitor session error: token authentication failed" | tee --append dnl_live_monitor.log
    exit 1
fi

filter_string=""
if [ -n "$filter_host" ]
then
    filter_string=${filter_string}"host ${filter_host}"
    if [ -n "$filter_port" ]
    then
        filter_string=${filter_string}" and "
    fi
fi
if [ -n "$filter_port" ]
then
        filter_string=${filter_string}"port ${filter_port}"
fi
    
if [ "$gather_rtp" = yes ]
then
    $PATH_TO_SNGREP --rtp -d any $filter_string 2>> dnl_live_monitor.log
else
    $PATH_TO_SNGREP -d any $filter_string 2>> dnl_live_monitor.log
fi

echo ""
